<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="身份证号" prop="fIdNo">
        <el-input
          v-model="queryParams.fIdNo"
          placeholder="请输入身份证号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="申报状态" prop="fRepStatus">
        <el-select v-model="queryParams.fRepStatus" placeholder="请选择申报状态" clearable size="small">
          <el-option
            v-for="dict in fRepStatusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="inforList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="身份证号" align="center" prop="fIdNo" />
      <el-table-column label="姓名" align="center" prop="fName" />
      <el-table-column label="专家表现评价" align="center" prop="fExpertEval" :show-overflow-tooltip="true"/>
      <el-table-column label="选用事件" align="center" prop="fSelectionEvent" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <span v-if="scope.row.fSelectionEvent != null">{{ scope.row.fSelectionEvent }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="选用开始时间" align="center" prop="fSelectionStartTime" width="150">
        <template slot-scope="scope">
          <span v-if="scope.row.fSelectionStartTime != null">{{ scope.row.fSelectionStartTime }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="评分说明" align="center" prop="fScorDesc" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <span v-if="scope.row.fScorDesc != null">{{ scope.row.fScorDesc }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="最后修改时间" align="center" prop="fUpdateTime" width="150"/>
      <el-table-column label="申报状态" align="center" prop="fRepStatus" :formatter="fRepStatusFormat" />
      <el-table-column label="申报时间" align="center" prop="fRepDate">
        <template slot-scope="scope">
          <span v-if="scope.row.fRepDate != null">{{ scope.row.fRepDate }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleReport(scope.row)"
            v-if="scope.row.fRepStatus == 2"
          >申报</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改专家行为申报对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body append-to-body destroy-on-close :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="专家" prop="fIdNo">
<!--          <el-input v-model="form.fIdNo" placeholder="请输入身份证号" :maxlength="18"/>-->
          <el-select v-model="form.fIdNo" filterable placeholder="请选择专家" style="width: 100% !important;" @change="setfName">
            <el-option
              v-for="item in userList"
              :key="item.fIdNo"
              :label="item.fShowName"
              :value="item.fIdNo">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="姓名" prop="fName" v-show="false">
          <el-input type="input" v-model="form.fName" placeholder="请选择身份证号"  readonly />
        </el-form-item>
        <el-form-item label="专家表现评价" prop="fExpertEval">
          <el-input type="textarea" v-model="form.fExpertEval" placeholder="请输入专家表现评价" />
        </el-form-item>
        <el-form-item label="选用事件" prop="fSelectionEvent">
          <el-input type="textarea" v-model="form.fSelectionEvent" placeholder="请输入选用事件" />
        </el-form-item>
        <el-form-item label="选用开始时间" prop="fSelectionStartTime">
          <el-date-picker
            style="width: 100%"
            v-model="form.fSelectionStartTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择选用开始时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="评分说明" prop="fScorDesc">
          <el-input type="textarea" v-model="form.fScorDesc" placeholder="请输入评分说明" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 详情 -->
    <DetailInfo ref="detail"/>
  </div>
</template>

<script>
import { listInfor, getInfor, delInfor, addInfor, updateInfor, exportInfor, reportProBehInfo, getUserList } from "@/api/specialist/behInfo";
import DetailInfo from "./components/DetailInfo";
export default {
  name: "Infor",
  components: {
    DetailInfo
  },
  data() {
    return {
      userList: [],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专家行为申报表格数据
      inforList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 申报状态：1 已上报，2 未上报 字典
      fRepStatusOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        fIdNo: null,
        fRepStatus: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        fIdNo: [
          { required: true, message: "身份证号不能为空", trigger: "blur" },
          {
            pattern: /(^\d{15}$)|(^\d{17}([0-9]|X)$)/,
            message: '身份证号格式有误！',
            trigger: 'blur'
          }
        ],
        fExpertEval: [
          { required: true, message: "专家表现评价不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getUserList();
    this.getList();
    this.getDicts("t_expert_rep_status").then(response => {
      this.fRepStatusOptions = response.data;
    });
  },
  methods: {
    /** 查询专家行为申报列表 */
    getList() {
      this.loading = true;
      listInfor(this.queryParams).then(response => {
        this.inforList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getUserList() {
      getUserList().then(response => {
        console.log(response.data)
        this.userList = response.data;
      });
    },
    setfName(value){
      let obj = {};
      obj = this.userList.find((item)=>{
        return item.fIdNo === value;
        ``});
      this.form.fName = obj.fName;
      //this.form.fIdNo = value;
    },
    // 申报状态：1 已上报，2 未上报，3 已通过，4未通过 字典翻译
    fRepStatusFormat(row, column) {
      return this.selectDictLabel(this.fRepStatusOptions, row.fRepStatus);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        fProBehInforId: null,
        fIdNo: null,
        fExpertEval: null,
        fSelectionEvent: null,
        fSelectionStartTime: null,
        fScorDesc: null,
        fUpdateTime: null,
        fRepStatus: null,
        fRepDate: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.fProBehInforId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专家行为申报";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const fProBehInforId = row.fProBehInforId || this.ids
      getInfor(fProBehInforId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专家行为申报";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.fProBehInforId != null) {
            updateInfor(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInfor(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const fProBehInforIds = row.fProBehInforId || this.ids;
      this.$confirm('是否确认删除专家行为申报编号为"' + fProBehInforIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delInfor(fProBehInforIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有专家行为申报数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportInfor(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    //详情
    handleDetail(row){
      this.$refs.detail.getDetailInfo(row.fProBehInforId);
    },
    //申报
    handleReport(row){
      this.$confirm('是否确认申报该专家行为数据?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return reportProBehInfo({ fProBehInforId : row.fProBehInforId});
      }).then(() => {
        this.getList();
        this.msgSuccess("行业专家申报成功");
      }).catch(() => {});
    }
  }
};
</script>
